import assert from 'assert';
import AESKey from '../src/aesKey.js';
import { randomBytes } from 'crypto';

describe('AESKey', function () {
    it('should serialize and deserialize', function () {
        for (let i = 0; i < 50; i++) {
            var key1 = new AESKey();
            var key2 = AESKey.from(key1.toString())

            assert.equal(key1.toString(), key2.toString());
        }
    });

    it('should encrypt and decrypt bytes', function () {
        for (let i = 0; i < 50; i++) {
            var key = new AESKey();

            var message = randomBytes(33);
            var cipher = key.encrypt(message);
            var plain = key.decrypt(cipher);

            assert.equal(message.equals(plain), true);
        }
    });

    it('should encrypt and decrypt a string', function () {
        for (let i = 0; i < 50; i++) {
            var key = new AESKey();

            var message = Buffer.from(randomBytes(33)).toString('base64');
            var cipher = key.encryptStr(message);
            var plain = key.decryptStr(cipher);

            assert.equal(message, plain);
        }
    });
});
